'use strict';

angular.module('myApp.controllers', [])

.controller('InitCtrl', ['$scope','$location', 'SlaveApiService', function ($scope, $location, SlaveApiService) {

  SlaveApiService.checkUpdate().then(function(data) {

    console.log('checkUpdate');
    console.log(data);

    if(data.status=="success") {

      if(typeof data.data.update_status!='undefined'&&data.data.update_status==1) {

        location.reload(true);

      } else {

        // init

        SlaveApiService.init().then(function(data) {

          if(data.status=="success") {
            $location.path('/catalog');
          } else {
            $location.path('/login');
          }

        }, function(data) {

          $location.path('/login');

        });
      }
    } 
  }, function(data, status, headers, config) {
    if(data&&data.status&&data.status=="success") {

      // init

      SlaveApiService.init().then(function(data) {

        if(data.status=="success") {
          $location.path('/catalog');
        } else {
          $location.path('/login');
        }

      }, function(data) {

        $location.path('/login');

      });
    } else {
      $location.path('/login');
    }
  });



}])

.controller('LogoutCtrl', ['$scope', '$location', 'SlaveApiService', function($scope, $location, SlaveApiService) {

  SlaveApiService.doLogout().then(function(data) {

    $location.path('/');

  });

}])

.controller('LoginCtrl', ['$scope','$location', 'SlaveApiService', function($scope, $location, SlaveApiService) {

  $scope.username = '';
  $scope.password = '';
  $scope.statusMessage = '';

  $scope.waitForLogin = true;

  SlaveApiService.init().then(function(data) {

    $scope.waitForLogin = false;

    if(data.status=="success") {
      $location.path('/catalog');
    }

  }, function(data) {

    $scope.waitForLogin = false;

  });

  $scope.doLogin = function() {

    if(!$scope.waitForLogin) {

      $scope.waitForLogin = true;

      SlaveApiService.doLogin($scope.username, $scope.password).then(function(data) {

        $scope.waitForLogin = false;

        $scope.statusMessage = "";

        if(data.status=="success") {
          $location.path('/catalog/1');
        }

      }, function(data) {

        $scope.waitForLogin = false;

        if(data.status=="success") {
          $location.path('/catalog/1');
        } else {
          $scope.statusMessage = data.data;
        }
      });
    }
  };
}])
.controller('CatalogCtrl', ['$scope','$location', '$routeParams', 'SlaveApiService', function($scope, $location, $routeParams, SlaveApiService) {
  var downloadInterval = null,
  checkSyncInterval = null,
  currentDownload = null,
  downloading = 0;

  $scope.connecting = 0;
  $scope.initReady = false;
  $scope.serverData = {
    activeProducts: []
  };
  $scope.isSynced = true;
  $scope.waitForSync = false;

  function refreshProducts() {

    SlaveApiService.getActiveProducts().then(function(data) {

      if(data.status=="success") {

        $scope.serverData = data.data;

        // check if there is at least one product being downloaded
        var i=0;
        while(i<$scope.serverData.active_products.length&&$scope.serverData.active_products[i].downloading==0) i++;

        // if there is at least one product downloading, connecting time is over
        if(i<$scope.serverData.active_products.length&&$scope.serverData.active_products[i].downloading!=0) {
          downloading = 1;
          $scope.connecting = 0;
        } else {
          // still connecting
          downloading = $scope.connecting;
        }

        console.log('getActiveProducts:' + downloading);

        if(downloading == 1 && downloadInterval == null) {

          console.log('Setting interval');

          downloadInterval = setInterval(refreshProducts, 2000);

        } else if(downloading == 0) {

          console.log('Clearing interval');

          clearInterval(downloadInterval);

        }

      } else {
        console.log('getActiveProducts fail');
      }
    }, function(data) {
      console.log('getActiveProducts error');
    });
  }

  function startCheckingSync() {
    checkSyncInterval = setInterval(function () {
      SlaveApiService.checkSync().then(function(data) {
        if(data.data.qty_requests>0) {
          $scope.isSynced = false;
          clearInterval(checkSyncInterval);
        } else {
          $scope.isSynced = true;
        }
      }, function (data) {
        if(data && data.status && data.status != "success") {
          $scope.isSynced = true;
          clearInterval(checkSyncInterval);
        }
      });

    }, 5000);
  }

  // verify session
  SlaveApiService.init().then(function(data) {

    if(data.status=="success") {
      $scope.initReady = true;
      refreshProducts();
      startCheckingSync();
    } else {
      $location.path('/login');
    }

  }, function(data) {
    $location.path('/login');
  });

  $scope.doSync = function() {
    if(!$scope.waitForSync) {
      $scope.waitForSync = true;

      SlaveApiService.doSync().then(function(data) {
        $scope.waitForSync = false;
        if(data.status=="success") {
          $scope.serverData = data.data;

          // if(data.data.sync_requests&&data.data.sync_requests.max_attempts>0) {
          //   // alert('Some exercises haven\'t been uploaded because the maximum number of attempts was reached');
          //   alert('You have now reached your 3 attempt limit');
          // }

          $location.path('/catalog');
        } else {
          if(data.data) alert(data.data);
        }

        refreshProducts();
        startCheckingSync();

      }, function(data) {
        $scope.waitForSync = false;
        // if(data.data) alert(data.data);
      });
    }
  };

  $scope.startDownload = function(isbn) {

    if(downloading==0) {

      var i=0;
      while(i<$scope.serverData.active_products.length&&$scope.serverData.active_products[i].isbn!=isbn) i++;

      if(i<$scope.serverData.active_products.length&&$scope.serverData.active_products[i].isbn==isbn) {
        $scope.serverData.active_products[i].downloading=1;
        $scope.serverData.active_products[i].download_legend="Connecting ...";
      }

      currentDownload = isbn;

      $scope.serverData.downloading = 1;
      $scope.connecting = 1;
      downloading = 1;

      SlaveApiService.startDownload(isbn).then(function(data) {

        refreshProducts();

      }, function(data, status, headers, config) {

        $scope.connecting = 0;
        clearInterval(downloadInterval);

        refreshProducts();

        if(data&&data.status&&data.status=="fail"&&data.data) {
          alert(data.data);
        } 
      });

      setTimeout(function() {
        downloadInterval = setInterval(refreshProducts, 2000);
        // refreshProducts()
      }, 6000);

    } else alert('Download in progress');
  };

  $scope.doPause = function(isbn) {
      SlaveApiService.pause(isbn).then(function(data) {
      }, function(data, status, headers, config) {
      });
  };

  if($routeParams.sync==1) $scope.doSync();

}]);

