<?php

class Curl_com {

    private $info_request = NULL;

    public function post($options = array())
    {
        $response = FALSE;

        if(isset($options['resource']))
        {
            $ch = curl_init($options['resource']);

            curl_setopt($ch, CURLOPT_POST, TRUE);

            if(isset($options['params']))
            {
                curl_setopt($ch, CURLOPT_POSTFIELDS, $options['params']); 
            }

            $response = $this->_common_config($ch, $options);
        }

        return $response;
    }

    public function put($options = array())
    {
        $response = FALSE;

        if(isset($options['resource']))
        {
            $ch = curl_init($options['resource']);

            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");

            if(isset($options['params']))
            {
                curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($options['params']));
                // curl_setopt($ch, CURLOPT_POSTFIELDS, $options['params']); 
            }

            $response = $this->_common_config($ch, $options);
        }

        return $response;
    }

    public function get($options = array())
    {
        $response = FALSE;

        if(isset($options['resource']))
        {
            if(isset($options['params']))
            {
                $params = array();
                foreach($options['params'] as $p => $v)
                {
                    $params[] = $p.'='.urlencode($v);
                }

                $options['resource'] .= '?'.implode('&', $params);
            }

            $ch = curl_init($options['resource']);

            $response = $this->_common_config($ch, $options);
        }

        return $response;
    }

    private function _common_config($ch, $options)
    {
        if(isset($options['headers']))
        {
            curl_setopt($ch, CURLOPT_HTTPHEADER, $options['headers']);
        }

        if(isset($options['cookie']))
        {
            curl_setopt($ch, CURLOPT_COOKIE, $options['cookie']);
        }

        if(isset($options['timeout']))
        {
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $options['timeout']);    
        }

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        // OJO esto introduce riesgo en seguridad (MITM): http://ademar.name/blog/2006/04/curl-ssl-certificate-problem-v.html
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        $response = curl_exec($ch);

        if(isset($options['format']))
        {
            if($options['format']=='xml')
            {
                // TODO return xml format. Not required yet. 
            }
            elseif($options['format']=='json')
            {
                $response = json_decode($response, TRUE);
            }
        }

        if(curl_errno($ch))
        {
            log_message('error', 'Curl_com: ' . curl_error($ch));
            log_message('error', print_r($options, TRUE));
        }

        $this->info_request = curl_getinfo($ch);

        curl_close($ch);

        return $response;
    }

    public function get_info_request($key = '')
    {
        return empty($key)
            ? $this->info_request
            : $this->info_request[$key]
            ;
    }
}
