<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once 'pclzip.php';

class My_pclzip {

    public function extract($path, $destination)
    {
        clearstatcache();

        log_message('info', 'My_pclzip starting extract');
        log_message('info', 'Path: ' . $path);
        log_message('info', 'Destination: ' . $destination);
        log_message('info', file_exists($path) ? 'File exists' : 'File doesn\'t exist');
        log_message('info', is_readable($path) ? 'Is readable' : 'No readable');

        try
        {
            $zip = new PclZip($path);

            $list = $zip->extract(PCLZIP_OPT_PATH, $destination, PCLZIP_OPT_REPLACE_NEWER);
        }
        catch(Exception $e)
        {
            log_message('error', display_exception($e));
        }

        log_message('info', 'Extract finished');

        if ($list == 0) {
            throw new Exception('Unrecoverable error "'.$zip->errorName(). '"' . $zip->errorInfo());
        }

        log_message('info', 'My_pclzip:extract: ok');

        return $list;
    }

}
