<?php

class Sams {
    protected $url = '';
    protected $last_curl_error = '';
    protected $last_curl_errno = 0;
    protected $last_response = '';
    public $SID = NULL;

    public function __construct()
    {
        $this->ci =& get_instance();
        $this->ci->load->library('curl_com');
        $this->url = $this->ci->config->item('url_sams');
    }

    private function _json_response()
    {
        $resp = json_decode(trim($this->last_response, '();'), TRUE);
        return $resp;
    }

    public function get_valid_sid()
    {
        log_message('info', 'Sams::get_valid_sid');
        $this->ci->load->helper('cookie');
        $SID = get_cookie('MEC_WS_SESSIONID');

        if(!empty($this->SID)&&!empty($SID)&&$this->SID==$SID)
        {
            // if the session has been already checked, don't ask to the server.
        }
        else
        {
            if(!empty($SID))
            {
                log_message('info', 'SID found in cookie: ' . $SID);

                $validate = $this->is_valid_session_id($SID);

                if(!$validate)
                {
                    // if it is not a valid $SID, try to get a new one
                    $SID = $this->get_session_id();
                    log_message('info', 'New SID: ' . $SID);
                }
                else
                {
                    log_message('info', 'Valid SID');
                }
            }
            else
            {
                log_message('info', 'SID not found in cookie');
                $SID = $this->get_session_id();
            }
        }

        if(!empty($SID))
        {
            log_message('info', 'Writing ' . $SID . ' in cookie');
            $this->SID = $SID;
            $this->set_cookie($SID);
        }
        else
        {
            log_message('info', 'Sams::get_valid_sid: SID not found');
        }

        return $SID;
    }

    public function is_valid_session_id($SID)
    {
        $this->last_response = $this->ci->curl_com->post(array(
            'resource' => $this->url,
            'timeout' => 5,
            'params' => array(
                'SID' => $SID,
                'action' => 'is_valid_session_id',
            )
        ));

        $response = $this->_json_response();

        return $response['status']==18;
    }

    public function get_session_id()
    {
        $response = $this->ci->curl_com->get(array(
             'resource' => $this->url . '&action=get_session_id_html&parenturl=http%3A%2F%2Ftiger.macmillan.es%2F',
             'timeout' => 5,
        ));

        preg_match('/WS_sessionID=(?P<sessionID>\w+)/', $response, $matches);

        if(isset($matches['sessionID']))
        {
            $this->set_cookie($matches['sessionID']);
            return $matches['sessionID'];
        }

        return FALSE;
    }

    public function login($options)
    {
        $options['action'] = 'loginpost';

        $this->last_response = $this->ci->curl_com->post(array(
            'resource' => $this->url,
            'timeout' => 5,
            'params' => $options
        ));

        $response = $this->_json_response();

        return $response['status']==2&&isset($response['SAMS_ID'])
            ? $response['SAMS_ID']
            : FALSE;
    }

    public function get_user_details($SID)
    {
        $this->last_response = $this->ci->curl_com->post(array(
            'resource' => $this->url . '&action=getuserdetails',
            'timeout' => 5,
            'cookie' => 'MEC_WS_SESSIONID=' . $SID
        ));

        $response = $this->_json_response();

        return !empty($response['result'])&&isset($response['user'])
            ? $response['user']
            : FALSE
            ;
    }

    public function set_cookie($SID)
    {
        $this->ci->input->set_cookie(array(
            'name' => 'MEC_WS_SESSIONID',
            'value' => $SID,
            // an empty $SID will mark the cookie as expired
            'expire'=> empty($SID) ? (time()-3600) : COOKIE_TIMESTAMP,
            'path' => '/',
            'domain' => '127.0.0.1',
        ));
    }

    public function remove_cookie()
    {
        $this->set_cookie('');
    }
}
