<?php

class Sams_soap {
    protected $url = '';

    public function __construct()
    {
        $this->ci =& get_instance();
        $this->url = $this->ci->config->item('url_soap');
    }

    public function get_raw_active_products($SID)
    {
        $body = '<?xml version="1.0" encoding="UTF-8"?><soapenv:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:urn="urn:http.service.bussiness.autenticacion.oc"><soapenv:Header/><soapenv:Body><urn:obtenerProductos>1</urn:obtenerProductos></soapenv:Body></soapenv:Envelope>';

        // $context_options = array(
        //     'http' => array(
        //         'method' => 'POST',
        //         'header' => 'Content-Type: multipart/form-data\r\n'
        //         . 'Cookie: MEC_WS_SESSIONID=' . $SID . '\r\n',
        //         // 'header' => array(
        //         //     'Content-Type: multipart/form-data\r\n',
        //         //     'Cookie: MEC_WS_SESSIONID=' . $SID . '\r\n'
        //         // ),
        //         'content' => $body
        //     )
        // );

        // $context = stream_context_create($context_options);
        // $fp = fopen($this->url, 'r', FALSE, $context);

        // $ret = stream_get_contents($fp);
        // log_message('info', 'Response: ' . $ret);

        // fsockopen METHOD
        // $fp = fsockopen('tiger.macmillan.es', 80, $errno, $errstr, 10);

        // if(!$fp) log_message('error', 'fsockopen: ' . $errno . ' - ' . $errstr);

        // $out = 'POST  /offline/macmsoap/index.php/api/index  HTTP/1.1\r\n'; 
        // $out .= 'Host: tiger.macmillan.es\r\n';
        // $out .= 'Cookie: MEC_WS_SESSIONID='.$SID.'\r\n';
        // $out .= 'Content-Type: multipart/form-data\r\n';
        // // $out .= 'Content-Type: application/x-www-form-urlencoded\r\n';
        // $out .= 'Content-Length: ' . strlen($body) . '\r\n';
        // $out .= 'Connection: close\r\n\r\n'; 
        // $out .= $body;

        // log_message('info', 'Enviando: ' . $out);

        // fwrite($fp, $out);

        // $ret = '';

        // while($line = stream_get_line($fp, 65535, '\n'))
        // {
        //     $ret .= $line;
        // }
        // while($line = fgets($fp))
        // {
        //     $ret .= $line;
        // }
        // while(!feof($fp))
        // {
        //     $f = fgets($fp, 128);
        //     var_dump($f);
        //     log_message('info', 'FG:' . $f);
        //     $ret .= $f;
        //     // $ret .= fgets($fp, 128);
        // }
        // fclose($fp);

        // log_message('info', 'Response: ' . $ret);

        $fp_curl_log = fopen(APPPATH . 'logs' . DIRECTORY_SEPARATOR . 'curl_soap.log', 'w');

        // CURL METHOD
        $ch = curl_init($this->url);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_STDERR, $fp_curl_log);

        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, urlencode($body));
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);    
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: multipart/form-data',
            // 'User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:24.0) Gecko/20100101 Firefox/24.0 (Portable)'
        ));
        curl_setopt($ch, CURLOPT_COOKIE, 'MEC_WS_SESSIONID='.$SID);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        $last_response = curl_exec($ch);
        $ret = FALSE;

        $curl_errno = curl_errno($ch);
        $curl_error = curl_error($ch);

        log_message('info', 'Soap request:');
        log_message('info', print_r(curl_getinfo($ch), TRUE));

        curl_close($ch);
        fclose($fp_curl_log);

        if($curl_errno==0)
        {
            // parse response
            $ret = $last_response;
        }
        else 
        {
            throw new Exception('curl(' . $curl_errno . '): ' . $curl_error);
        }

        log_message('info', 'Soap response (SID: ' . $SID . '): ' . $ret);

        $doc = new DOMDocument();
        $doc->loadXML($ret);


        $error = $doc->getElementsByTagName('faultstring');

        // if($error->length>0)
        // {
        //     throw new Exception($error->item(0)->nodeValue);
        // }

        $products = $doc->getElementsByTagName('obtenerProductosReturn')->item(0);


        $active_products = array();

        foreach($products->childNodes as $node)
        {
            $ap = array();

            foreach($node->childNodes as $data)
            {
                $ap[$data->nodeName] = $data->nodeValue;
            }

            $active_products[] = $ap;
        }

        return $active_products;
    }

    public function get_active_products($SID)
    {
        $products = $this->get_raw_active_products($SID);

        $active_products = array();

        foreach($products as $k => $p)
        {
            $active_products[] = array(
                'isbn' => $p['isbn'],
                'image' => $p['urlImagenPortada'],
                'title' => nl2br($p['nombreProducto']),
                'version' => $p['version'],
                'zip_file' => isset($p['zip']) ? $p['zip'] : NULL,
                'path' => isset($p['path']) ? $p['path'] : NULL,
            );
        }

        return $active_products;
    }
}
