<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Migration_Count_attempts extends CI_Migration {
    public function up()
    {
        $this->load->dbforge();

        $this->dbforge->add_column('portable_requests', array(
            'book_id' => array('type' => 'INT', 'null' => TRUE),
            'element_id' => array('type' => 'INT', 'null' => TRUE),
            'package_identifier' => array('type' => 'varchar', 'constraint' => '255', 'null' => TRUE),
            'item_identifier' => array('type' => 'varchar', 'constraint' => '255', 'null' => TRUE),
            'type' => array('type' => 'varchar', 'constraint' => '50', 'null' => TRUE),
        ));

        $this->dbforge->add_key('type');
        $this->dbforge->add_key(array('book_id', 'element_id', 'package_identifier', 'item_identifier'));
    }

    public function down()
    {
        $this->db->query('ALTER TABLE portable_requests DROP INDEX book_id_element_id_package_identifier_item_identifier');

        $this->dbforge->drop_column('portable_requests', 'book_id');
        $this->dbforge->drop_column('portable_requests', 'element_id');
        $this->dbforge->drop_column('portable_requests', 'package_identifier');
        $this->dbforge->drop_column('portable_requests', 'item_identifier');
        $this->dbforge->drop_column('portable_requests', 'type');
    }
}
