<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Product_model extends MY_Model {
    public $_table = 'portable_products';
    public $primary_key = 'isbn';

    public function insert_from_soap($soap_products = array())
    {
        $data = array();

        foreach($soap_products as $k => $row)
        {
            log_message('info', 'soap product: ' . print_r($row, TRUE));

            $data[$k] = array(
                'isbn' => $row['isbn'],
                'image' => basename($row['image']),
                'title' => $row['title'],
                'version' => $row['version'],
                'zip_file' => $row['zip_file']
            );

            $this->db->on_duplicate_update($this->_table, $data[$k], $data[$k]);
        }

        return TRUE;
    }

    public function get_by_user($sams_id, $options = array())
    {
        $this->db->select('p.*');
        $this->db->join('portable_products_x_users pu', 'pu.isbn = p.isbn', 'inner');
        $this->db->where('pu.sams_id', $sams_id);
        $query = $this->db->get($this->_table . ' p');

        return $query->result();
    }
}
