<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Request_model extends MY_Model {
    public $_table = 'portable_requests';
    public $primary_key = 'id';

    // protected $after_get = array('build_final_url');
    protected $before_create = array('prepare_identifiers');

    public function build_final_url($row)
    {
        // apply this only for exercise results
        if(!empty($row->json))
        {
            $row->final_url = $row->url . '?method=SET&json=' . $row->json;
        }

        return $row;
    }

    public function prepare_identifiers($row)
    {

        // apply this only for exercise results
        if(isset($row['json']))
        {
            $json = json_decode($row['json'], TRUE);

            if(isset($json['package_identifier'])) $row['package_identifier'] = $json['package_identifier'];
            if(isset($json['item_identifier'])) $row['item_identifier'] = $json['item_identifier'];
            if(isset($json['book_id'])) $row['book_id'] = $json['book_id'];
            if(isset($json['element_id'])) $row['element_id'] = $json['element_id'];
            if(isset($json['score'])) $row['score'] = $json['score'];
            if(isset($json['total'])) $row['total'] = $json['total'];
            if(isset($json['data'])) $row['exercise_data'] = $json['data'];

            unset($row['json']);
        }

        return $row;
    }

}
